#include <stdio.h>

/* A program celja:
- 10 elemu int tomb ertekeinek beolvasasa,
- adatok kimentese binaris fajlba
- adatok betoltese (a tomb_fajlbol nevu tombbe)
- adatok kiirasa
*/
int main()
{
	int tomb[10];	// Ide kerjuk majd be az adatokat a felhasznalotol
	int tomb_fajlbol[10];	// Ide olvassuk majd vissza oket a fajlbol
	int i;	// Ciklusokhoz index valtozo

	// A fajlokra a fajlmuveleteknel egy FILE nevu strukturaval tudunk hivatkozni.
	// Az fopen (file megnyitasa) fuggvenytol kapunk ilyet (erre mutato pointer-t),
	// amikor megnyitjuk a fajlt (vagyis elkezdunk vele dolgozni).
	FILE *F_out = NULL;	// A kiiraskor ezzel hivatkozunk majd a fajlra.
	FILE *F_in = NULL;	// A betolteskor meg ezzel.

	// Beolvasunk 10 szamot a tombbe...
	for(i=0; i<10; i++) {
		printf("Az %d. elem: ",i);
		scanf("%d",&tomb[i]);
	}

	// Kimentjuk a "tomb" tartalmat fajlba.
	// Ez a kovetkezo lepesekbol all:
	// - Megnyitas (megmondjuk, hogy melyik fajllal akarunk dolgozni es mit akarunk tenni.)
	// - Ellenorizzuk, hogy sikerult-e megnyitni
	// - Kiirjuk bele az adatokat
	// - Megmondjuk az operacios rendszernek, hogy ha esetleg meg nem irt volna ki mindent,
	//	akkor most tegye meg. (Lehet, hogy a rendszer meg varakozik, hatha lesz valami, es
	//	akkor majd egyutt ir ki sok adatot.)
	// - Lezarjuk a fajlt
	F_out = fopen("adatok.dat","wb");	// Nyissuk meg az "adatok.txt"-t irasra (W), binarisan (B)
	// (Ha esetleg letezett volna az adatok.dat, akkor most jol felulirjuk!)
	if (F_out == NULL) {	// NULL-t kapunk, ha nem sikerult...
		printf("Nem sikerult. :(\n");
		return 1;	// Program vege, valami nem sikerult...
	}
	// A kiirashoz a kovetkezo adatok kellenek:
	// - Honnan irunk ki adatokat (pointer az adatok elejere, most a tomb elejere)
	// - Mekkora adatokat irunk ki? (most az int merete)
	// - Hany ekkora adatot irjunk ki? (10-et)
	// - Es melyik fajlba? (F_out-ba)
	fwrite(tomb,sizeof(int),10,F_out);	// Kiiras: honnan, mekkora elemeket, hanyat, hova
	fflush(F_out);	// Minden fuggoben maradt irast fejezzunk be
	fclose(F_out);	// Fajl lezarasa.

	// Most akkor toltsuk vissza az adatokat
	F_in = fopen("adatok.dat","rb");	// Megnyitas olvasasra (R), binarisan (B)
	if (F_in == NULL) {	// Ha nem sikerult, akkor pech... program vege...
		printf("Nem sikerult. :(\n");
		return 2;
	}
	// Az olvasas nagyon hasonlit az irasra, a parameterek pont ugyanazok, csak az
	//	adatmozgas iranya forditott...
	fread(tomb_fajlbol,sizeof(int),10,F_in);	// Olvasas: hova, mekkora elemeket, hanyat, honnan
	fclose(F_in);	// Fajl lezarasa. (Olvasaskor nem kell fuggoben maradt muveletekkel bajlodni...)

	// Es kiirjuk az elemeket...
	for(i=0; i<10; i++) {
		printf("Az %d. elem: %d\n",i,tomb_fajlbol[i]);
	}

	return 0;	// Minden szepen sikerult, program vege...

	// Erdemes belenezni az adatok.dat-ba. Semmi ertelmes szoveg nincsen benne, csak tisztan
	// a tomb tartalma. Merete Windows XP alatt peldaul 40 byte, mert az int tipus merete
	// itt 4 byte. (DOS alatt peldaul csak 2 byte, igy ott kisebb lenne a fajl...)
}
